/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

// Wait for the deviceready event before using any of Cordova's device APIs.
// See https://cordova.apache.org/docs/en/latest/cordova/events/events.html#deviceready


function readPdf(pathWeb, pathAndroid, file) 
{
  var app = document.URL.indexOf( 'http://' ) === -1 && document.URL.indexOf( 'https://' ) === -1;
  if(app) // Siamo nell'APK
  {
    cordova.plugins.fileOpener2.showOpenWithDialog(
      pathAndroid+file,
      'application/pdf', 
      { 
        error : function(e) 
        { 
            //  Il file.pdf non e' stato ancora scaricato dal server. Quindi si scarica e poi si apre
            creaDir(pathWeb, localStorage.pathLocalePdf, file.substring(0,8), file);
        },
        success : function () 
        {
            //alert('file opened successfully'); 				
        }
      }
    );
  }
  else
  {
    var ref = window.open(pathWeb+file, '_self', 'location=yes', 'hidden=yes');
  }	  
}

// CREAZIONE DIRECTORY
function creaDir(pathWeb, father_dir, children_dir, file)
{
	window.resolveLocalFileSystemURL(father_dir,
		function fileEntryCallback(fileEntry) {
			function success(dirEntry) {
        scaricaPdf(pathWeb, father_dir + children_dir+ '/' , file);
      }

      function fail(error) {
          alert("Unable to create new directory: " + error.code);
      }
      fileEntry.getDirectory(children_dir, {create: true, exclusive: false}, success, fail);
		}
	);
  return "SUCCESS";
}

function scaricaPdf(pathWeb, pathAndroid, file) 
{ 
  var fileURL = pathWeb + file;
  var req = new XMLHttpRequest();
  req.open("GET", fileURL, true);
  req.responseType = "blob";

  req.onload = function (event) 
  {
    var blob = req.response;
      
    if(req.status == 200)
    {
      window.resolveLocalFileSystemURL(pathAndroid, function (directoryEntry) 
      {
        directoryEntry.getFile(file, { create: true }, function (fileEntry) 
        {
          fileEntry.createWriter(function (fileWriter) 
          {
            fileWriter.onwriteend = function (e) 
            {
              readPdf('pathWeb', pathAndroid, file); // pathWeb non serve qui
            };
    
            fileWriter.onerror = function (e) 
            {
              alert('Write failed');
            };
            fileWriter.write(blob);
          } );
        } );
      });
    }
    else
    {
      alert('Errore status:'+req.statusText);
    }
  };
  req.onerror = function() { alert('NPM '+req.statusText); }
  req.send();
}
